map = require 'map'

snake1 = love.filesystem.load 'snake.lua' () {0, 192, 0}
snake2 = love.filesystem.load 'snake.lua' () {0, 0, 192}

love.load = function()
	grey = love.image.newImageData(800, 600)
	grey:mapPixel(function() return 128, 128, 128, 128 end)
	grey = love.graphics.newImage(grey)
	fonts = {}
	setmetatable(fonts, {__index = function(t, i) t[i] = love.graphics.newFont(i) return t[i] end})
	symbols = {}
	symbols[true] = '\\'
	symbols[false] = '/'
	back = true
end


love.update = function(dt)
	for i, v in ipairs(snake2.squares) do
		snake1.colliding = (v[1] == snake1.x and v[2] == snake1.y) or snake1.colliding
	end
	for i, v in ipairs(snake1.squares) do
		snake2.colliding = (v[1] == snake2.x and v[2] == snake2.y) or snake2.colliding
	end
	if not snake1.colliding and not snake2.colliding then
		snake1:update(dt)
	end
	if not snake1.colliding and not snake2.colliding then
		snake2:update(dt)
	end
	if not (snake2.colliding or snake1.colliding) then
		map:update(dt)
	end
end

love.draw = function()
	love.graphics.draw(canvas, 0, 0)
	snake1:draw()
	snake2:draw()
	love.graphics.print(symbols[back], (map.width)*18, 1)
	love.graphics.print(love.timer.getFPS(), map.width*18, 12)
--	love.graphics.print(tostring(snake.colliding), map.width*18, 24)
	if snake1.colliding then
		love.graphics.draw(grey, 0, 0)
		love.graphics.setFont(fonts[96])
		love.graphics.printf("Game Over, 2 won", 0, 204, 800, 'center')
		love.graphics.setFont(fonts[12])
	end
	if snake2.colliding then
		love.graphics.draw(grey, 0, 0)
		love.graphics.setFont(fonts[96])
		love.graphics.printf("Game Over, 1 won", 0, 204, 800, 'center')
		love.graphics.setFont(fonts[12])
	end
end

love.keypressed = function(key, unicode)
	if snake1.keytimer >= 0.15 then
		if key == 'up' and snake1.direction[2] ~= 1 then
			snake1.direction = {0, -1}
			keytimer = 0
		elseif key == 'down' and snake1.direction[2] ~= -1 then
			snake1.direction = {0, 1}
			keytimer = 0
		elseif key == 'right' and snake1.direction[1] ~= -1 then
			snake1.direction = {1, 0}
			keytimer = 0
		elseif key == 'left' and snake1.direction[1] ~= 1 then
			snake1.direction = {-1, 0}
			keytimer = 0
		end
	end
	if snake2.keytimer >= 0.15 then
		if key == 'w' and snake2.direction[2] ~= 1 then
			snake2.direction = {0, -1}
			keytimer = 0
		elseif key == 's' and snake2.direction[2] ~= -1 then
			snake2.direction = {0, 1}
			keytimer = 0
		elseif key == 'd' and snake2.direction[1] ~= -1 then
			snake2.direction = {1, 0}
			keytimer = 0
		elseif key == 'a' and snake2.direction[1] ~= 1 then
			snake2.direction = {-1, 0}
			keytimer = 0
		end
	end
end