function createSnake(color)
local	snake = {}
	snake.canvas = love.graphics.newCanvas(map.width*18, map.height*18)
	snake.keytimer = 0.15
	snake.x = math.random(map.width)
	snake.y = math.random(map.height)
	snake.length = 4
	snake.direction = {-1, 0}
	snake.timer = 0
	snake.update = function(self, dt)
		self.timer = self.timer + dt
		self.keytimer = self.keytimer + dt
		if self.timer > 0.2 then
			table.insert(self.squares, {self.x, self.y})
			back = not back
			self.x = self.x + self.direction[1]
			self.y = self.y + self.direction[2]
			if self.x > map.width then
				self.x = 1
			elseif self.x < 1 then
				self.x = map.width
			end
			if self.y > map.height then
				self.y = 1
			elseif self.y < 1 then
				self.y = map.height
			end
			self.timer = self.timer - 0.2
			self.colliding = self.colliding or false
			for i, v in ipairs(self.squares) do
				snake.colliding = (v[1] == self.x and v[2] == self.y) or snake.colliding
			end
			if #self.squares > self.length then
				table.remove(self.squares, 1)
			end
			self.canvas:clear()
			for i, v in ipairs(self.squares) do
				self.canvas:renderTo(function() love.graphics.draw(snake.squares['#'], (v[1]-1)*18+1, (v[2]-1)*18+1) end)
			end
		end
	end
	snake.squares = {{snake.x, snake.y}}
	snake.squares['#'] = love.image.newImageData(16, 16)
	snake.squares['#']:mapPixel(function() return color[1] or 0, color[2] or 192, color[3] or 0, color[4] or 255 end)
	snake.squares['#'] = love.graphics.newImage(snake.squares['#'])
	setmetatable(snake.squares, {__index = function() return {-5, -5} end})
	snake.draw = function(self)
		love.graphics.draw(self.canvas, 0, 0)
	end
	
	return snake
end
return createSnake